#Nathan Polak
#Sonification of Chicago's Violent Crime and Temperature Data

orc = """
sr=44100
ksmps=32
nchnls=2
0dbfs=1

; <instrument Nr 1 definition>
instr 1
iamp = 0.8		; amplitude (max = 1) hard-wired here
				; easy to make it a p-field or adjust it to avoid samples out-of-range
ifreq = 300									
;            t1   t2 val(t2) t3   val(t3)   dur val(release)
kenv linsegr 0, 0.05,    1,  0.05, 0.7,    0.4, 0        ; see http://csound.com/docs/manual/linsegr.html
kenv2 linsegr 0, 0.07,    1,  0.05, 0.7,    0.4, 0 
aout vco2 iamp * kenv, ifreq
aou2 vco2 iamp * kenv2, ifreq*(6/5.0)
a1rev reverb aout, .4 ; reverb time is .4
a2rev reverb aou2, .4 ; reverb time is .4
outs a1rev, a2rev 
endin

; </instrument 4 definition>
instr 4
;idamp = 			;vary damping amount
asig stix 0.4, 1, 30, 0.98
     outs asig, asig

endin

; <instrument 2 definition>
instr	2 ; play audio from disk                        
kSpeed  init     1; playback speed
iSkip   init     0; inskip into file (in seconds)
iLoop   init     0; looping switch (0=off 1=on)
; READ AUDIO FROM DISK
a1, a2      diskin2  "gun.wav", kSpeed, iSkip, iLoop
a1rev reverb a1, .2 ; reverb time is .2
a2rev reverb a2, .2 ; reverb time is .2

out      a1rev, a2rev      ; send audio to outputs
endin
;

; <instrument 3 definition>
instr	3 ; play audio from disk                       
kSpeed  init     1; playback speed
iSkip   init     0; inskip into file (in seconds)
iLoop   init     0; looping switch (0=off 1=on)
; READ AUDIO FROM DISK
a1, a2      diskin2  "knife.wav", kSpeed, iSkip, iLoop
a1rev reverb a1, .1 ; reverb time is .1
a2rev reverb a2, .1 ; reverb time is .1
out      a1rev*.7, a2rev*.7      ; send audio to outputs
endin
;

;
; <instrument 5 definition>
instr 5
ia = p4
ib = p5
iz = p6
;kenv1 linsegr ia, 1, ib, 1, iz 
kres expsegr ia, p3*.5, ib, p3, iz
asig oscili  0.03,  kres        ;f 1 0 4096 10 0 1
     outs asig, asig

endin


"""
import csv
import itertools
import time
import numpy 
from datetime import datetime
import ctcsound						# our csound wrapper friend
from random import randint			# randint (2, 30) returns a random int between2 and 30
c = ctcsound.Csound()    				# create an instance of Csound
c.setOption("-odac") 				# Set option for Csound !!!!!!!!!!!!!!!!!!!!!!!!!!!!

c.compileOrc(orc)     # Compile Orchestra from the orc string, defined above


debug = True
debug = False



inDir = "/Users/nathanpolak/Python/DatSon/Project/"      #directory of data file
inDir = "/Users/davidworrall/Documents/CCC/TEACHING/SP18_classes/18-SP_DSonClass/NathanPolak"

Crime="Crime.csv"                                        #Crime data
Temp="temp2.csv"                                         #Temperature data
crimeName=inDir+Crime
tempName=inDir+Temp

#drw in assessment:
#filePointer = open(crimeName, 'r')                       
filePointer = open(Crime, 'r')                       
DataList = filePointer.read()                            #Read crime data as DataList
DataList = DataList.split("\r")
nrRows=len(DataList)                                     #length of crime data                             

#drw in assessment:
#tempPointer = open(tempName, 'r')
tempPointer = open(Temp, 'r')
tempList = tempPointer.read()                            #Read temperature data as 
tempList = tempList.split("\r")
teRows = len(tempList)                                   #Lengthon of temperature data


     
crimeTypes=[]                                            #Will become list of type identifiers for each crime event
eventTimes=[]                                            #Will become list of event start times for each crime event
startDate = datetime.strptime('1/1', "%m/%d")
for row in range(nrRows):                                #Process crime!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    DataList[row]=DataList[row].split(",")
    DataList[row][0]=DataList[row][0].replace("\n", "")
    DataList[row][1]=DataList[row][1].split(" ")
    if 'HOMICIDE' in DataList[row][2]:                  #Assign each crime a numeric type based on type of crime
        if 'FIRST DEGREE MURDER' in DataList[row][3]:
            cType=1                                     #Intentional homicide is type 1
            DataList[row].append(cType)                 #append type to event in crime data and to list of crime event types
            crimeTypes.append(cType)
        else:
            cType=10                                    #ignore accidental homicide. Still assign a type (10) for structure consistency
            DataList[row].append(cType)
            crimeTypes.append(cType)
        
    elif 'BATTERY' in DataList[row][2]:
        if 'GUN' in DataList[row][3]:                   #aggravated battery w gun type is 2
            cType=2 
            DataList[row].append(cType)
            crimeTypes.append(cType)
        elif 'FIREARM' in DataList[row][3]:             #aggravated battery w gun type is 2
            cType=2 
            DataList[row].append(cType)
            crimeTypes.append(cType)
        elif 'KNIFE' in DataList[row][3]:               #aggravated battery w knife type is 3
            cType=3      
            DataList[row].append(cType)
            crimeTypes.append(cType)
        else:
            cType=4                                     #"other" battery type is 4
            DataList[row].append(cType)
            crimeTypes.append(cType)

    else:
        cType=4                                         #other violent crime type is 4
        DataList[row].append(cType)
        crimeTypes.append(cType)

    if debug:                                           #Debug-------------------------------------------------------------------
        print (DataList[row])
        print (crimeTypes[row])

    for colNr in range (len (DataList[row])):
        temp = DataList[row][colNr]			        # the contents of the cell
        try:
            number = float(temp)					# try to float the string
            if '.' not in temp:						# if it floats and there is not a '.' in it,
                number = int (temp)					# it is an int
            DataList[rowNr][colNr] = number		    # assign the value
        except:										# it is not a numeric
            pass
    if debug:                                                       #Debug------------------------------------------------------------------
        print (DataList[row])

                                                                    #convert total number of minutes to date
    rawDateSt=DataList[row][1][0]                                   #raw time             
    date=datetime.strptime(rawDateSt, "%m/%d")                      
    nrDays=(date-startDate).days
    nrDaysMins=(date-startDate).total_seconds() / 60
    
    if debug:                                                       #Debug-------------------------------------------------------------------
        print ("nrDays: %g nrDaysMins: %g " % (nrDays, nrDaysMins))
    
    rawTimeSt=DataList[row][1][1].split(':')                        #convert time of crime to minute of the day
    crimeMinutes = int(rawTimeSt[0]) *60 + int(rawTimeSt[1])

    if debug:                                                       #Debug-------------------------------------------------------------------
        print ("dateMinutes: ", crimeMinutes)

    minuteOfYear= nrDaysMins + crimeMinutes                         #add minute of day to total number of minutes to date
    
    if debug:                                                       #Debug-------------------------------------------------------------------
        print (minuteOfYear)

    playAtTime = (minuteOfYear * 60) / (43200  *2)                  #second of the sonification that the event occurs
    eventTimes.append(playAtTime)
    DataList[row][0]=playAtTime                                     #replace date of event in crime data with event start time 
    
    if debug:                                                       #Debug-------------------------------------------------------------------
        print (playAtTime)
averages=[]                                                         #Will become list of average daily temperatures ; starting temperature for the day in the sonification
secondAverage=[]                                                    #Will become list of average temperatures for the day following current day. Same as above list but without January 1st ; ending temperature for day in the sonification
midTemps=[]                                                         #Will become list of "midpoint" temperatures. ;  Mid temperature between average temp of current day and average temp of following day
tempStartDate = datetime.strptime('1/1', "%m/%d")
for row in range(teRows):                                            #Process Temp!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    tempList[row]=tempList[row].split(",")
    tempList[row][0]=tempList[row][0].replace("\n", "")
    for colNr in range (len (tempList[row])):
	    teTemp = tempList[row][colNr]			                     # the contents of the cell
	    try:
		    teNumber = float(teTemp)					             # try to float the string
		    if '.' not in teTemp:						             # if it floats and there is not a '.' in it,
			    teNumber = int (temp)					             # it is an int
		    tempList[rowNr][colNr] = teNumber		                 # assign the value
	    except:										                 # it is not a numeric
		    pass 
    temperatures=[int(tempList[row][1]), int(tempList[row][2])]      #High and low temperatures for the day
    average=numpy.mean(temperatures)                                 #Calculate average temperature for the day 
    tempList[row].append(average)                                    #append average to the row and to list of averages
    averages.append(average)                                                           
                                                                  
    
    rawTempDateSt=tempList[row][0]                                   #convert total number of minutes to date

    tempDate=datetime.strptime(rawTempDateSt, "%m/%d")
    nrTempDays=(tempDate-tempStartDate).days
    nrTempDaysMins=(tempDate-tempStartDate).total_seconds() / 60
    
    if debug:                                                        #Debug-------------------------------------------------------------------
        print ("nrDays: %g nrDaysMins: %g " % (nrTempDays, nrTempDaysMins))
    

    if debug:                                                        #Debug-------------------------------------------------------------------
        print ("dateMinutes: ", tempMinutes)

    tempMinuteOfYear= nrTempDaysMins                                 #add minute of day to total number of minutes to date
    
    if debug:                                                        #Debug-------------------------------------------------------------------
        print (")tempMinuteOfYear:", tempMinuteOfYear)

    playTempAtTime = (tempMinuteOfYear * 60) / (43200  *2)           #second of the sonification that the event occurs
    tempList[row][0]=playTempAtTime                                  #Replace date in Temp Data with playTempAtTime

    if debug:                                                        #Debug-------------------------------------------------------------------
        print (playTempAtTime)
for row in range(nrRows-teRows):                                     #Make Temp Data the same length as Crime Data to allow for proper playback
    tempList.append([370, 19, 19, 19])

for row in range(1, teRows):                                         #Calculate midTemp, Second Average from January 2nd to Dec 31 and append them to resepctive lists
    twoTemps=[tempList[row-1][3], tempList[row][3]]
    midTemp=int(numpy.mean(twoTemps))
    midTemps.append(midTemp)
    temperaturesTwo=[int(tempList[row][1]), int(tempList[row][2])]
    averageTwo=numpy.mean(temperaturesTwo)
    secondAverage.append(averageTwo)

for num in range(nrRows-len(midTemps)):                             #Make midTemps, Averages, secondAverage the same length as Crime Data for proper playback
    midTemps.append(0)
for num in range(nrRows-len(averages)):
    averages.append(0)
for num in range(nrRows-len(secondAverage)):
    secondAverage.append(0)


if debug:                                                           #Debug-------------------------------------------------------------------
    filePointer=open("testData.csv", "w")                           #write data to a file to test that it is still formatted correctly
    for row in range (nrRows):
	    filePointer.write(",".join (map (str, DataList[row]))+"\r") # write the data to file
    filePointer.close()	

myScore2 = "f 1 0 4096 10 0 1\n"			                        # FUNCTION TABLE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
timeOffsets = [row[0] for row in DataList]
tempTimeOffsets = [row[0] for row in tempList]
eventDur 	= 0.01		                                            # the duration of a homicide / "other" event (how long it lasts) in seconds
gunDur = 0.2                                                        #Duration of gun event
knifeDur = 0.2                                                      #Duration of knife event
tempDur = .5                                                        #Duration of temperature event (total is 1 second)

eventStartTime = timeOffsets[0]
tempStartTime = tempTimeOffsets[0]
for noteNr, row in zip(range(len(DataList)), range(len(tempList))): #Score Creation
    if DataList[noteNr][-1] == 4:                                   #"Other" violent crime
        eventStartTime = DataList[noteNr][0]
        thisNote = "i4 %g %g\n" % (eventStartTime, eventDur)                                       
        myScore2 += thisNote 


    elif DataList[noteNr][-1] == 1:                                 #Homicide 
        eventStartTime = DataList[noteNr][0]                                            
        thisNote = "i1 %g %g\n" % (eventStartTime, eventDur)                                       
        myScore2 += thisNote

    elif DataList[noteNr][-1] == 2:                                 #Gun event
        eventStartTime = DataList[noteNr][0]                                            
        thisNote = "i2 %g %g\n" % (eventStartTime, gunDur)                                         
        myScore2 += thisNote

    elif DataList[noteNr][-1] == 3:                                 #Knife event
        eventStartTime = DataList[noteNr][0]                                            
        thisNote = "i3 %g %g\n" % (eventStartTime, knifeDur)                                           
        myScore2 += thisNote

    tempStartTime = tempList[row][0]                                #Temperature events
    tempNote = "i5 %g %g %g %g %g\n" % (tempStartTime, tempDur, averages[row]*50, midTemps[row]*50, secondAverage[row]*50)
    
	
	                                            #print thisNote
    myScore2 += tempNote
#print myScore2

# :::::::::::: read the score ::::::::::::::::::::::::::::::::::::::::::
#c.ReadScore(myScore1)     # Read in Score from loop-generated String
c.readScore(myScore2)     # Read in Score from loop-generated String
# :::::::::::: start the csound sound synthesizer ::::::::::::::::::::::
c.start()             # When compiling from strings, this call is necessary before doing any performing


# :::::::::::: perform the score on the sound synthesizer ::::::::::::::
# Continue to perform blocks of sound. A return of 0,  signifies to keep processing.  
while (c.performKsmps() == 0):
  pass

c.stop()	# stop the synthesizer
 
 


